<?php


namespace App\Services;


use App\Models\User;
use Illuminate\Support\Facades\DB;

class HomeService
{
    /**
     * 获取首页内容
     * @param $param
     */
    public function get_list($param){

       // DB::select();

        $query = User::query()
            ->leftJoin("users_info",'users.id','=','users_info.user_id')
            ->select(['users.id','users.is_vip','users.tencent_im_user_id','users.sex','users.is_auth','users.latitude','users.longitude','users.online','users_info.avatar','users_info.nickname','users_info.area','users_info.birthday','users_info.height','users_info.weight'])
            ->addSelect(DB::raw("acos(cos(" .$param['latitude'] . "*pi()/180)*cos(cl_users.latitude*pi()/180)*cos(" . $param['longitude'] . "*pi()/180-cl_users.longitude*pi()/180)+sin(" . $param['latitude'] . "*pi()/180)*sin(cl_users.latitude * pi()/180)) * 6367000 AS distance"))
            ->orderBy('distance','ASC')
            ->paginate(request('perPage',20));
        $query = $query->toArray();
        foreach ($query['data'] as $k=>$v){
                $query['data'][$k]['age'] =!empty($v['birthday'])? birthday($v['birthday']):0;

                //计算距离
               // $query['data'][$k]['distance'] =  0;
        }
        return $query;
    }
}
